
#cs

GTT Extracttor Paste takes a file that was translated from an extraction using GTT Extracttor, i.e. it's a three column tab delmited text file in which the first column contains numbers and is therefore ignored.  The file created by GTT Extracttor has lines numbered from 0001 to whatever, but the strings are in reverse order, so the translator must reverse that file, then translate it, then reverse it again, before using this tool.

With this script, the user clicks in the target field, presses the hotkey, and the script then pastes the line.

#ce

; based on:
; Anypaste v3
; Samuel Murray, May 2017

Global $i, $j, $line, $lines

; MsgBox (0, "GTT Extracttor Paste", "GTT Extracttor Paste reads one line at a time and pastes it. Don't go too fast!" & @CRLF & @CRLF & "~ = paste current text" & @CRLF & "Ctrl + ~ = does Shift +ENTER" & @CRLF & @CRLF & "Shift + Ctrl + 1 = go back one" & @CRLF & "Shift + Ctrl + 2 = go forward one" & @CRLF & @CRLF & "Shift + Ctrl + F4/F1/F2/F3 = type {0}/{1}/{1}/{3}" & @CRLF & @CRLF & "Ctrl + ? = show shortcuts" & @CRLF & "WinKey + Q = close script", 0)

MsgBox (0, "GTT Extracttor Paste", "GTT Extracttor Paste reads one line at a time and pastes it. Don't go too fast!" & @CRLF & @CRLF & "~ = paste current text" & @CRLF & "Ctrl + ~ = does Shift + ENTER"  & @CRLF & "WinKey + ~ = does Ctrl + Home" & @CRLF & @CRLF & "Shift + Ctrl + 1 = go back one" & @CRLF & "Shift + Ctrl + 2 = go forward one" & @CRLF & @CRLF & "Ctrl + ? = show shortcuts" & @CRLF & "WinKey + Q = close script", 0)

$i = 1
$j = 1

$textfile = FileRead (FileOpen (FileOpenDialog ("Select file", @ScriptDir, "Text files (*.txt)|All files (*.*)"), 128))

$lines = StringSplit ($textfile, @CRLF, 1)

HotKeySet ("`", "paste")
HotKeySet ("^`", "shiftenter")
HotKeySet ("#`", "totop")

HotKeySet ("+^1", "goback")
HotKeySet ("+^2", "goforward")

HotKeySet ("^/", "helpme")
HotKeySet ("#q", "quitt")

; HotKeySet ("^`", "backactionpaste")
; HotKeySet ("+^{F4}", "curl0")
; HotKeySet ("+^{F1}", "curl1")
; HotKeySet ("+^{F2}", "curl2")
; HotKeySet ("+^{F3}", "curl3")

$mousepos = MouseGetPos ()
$mousepos[0] = $mousepos[0] + 50
$mousepos[1] = $mousepos[1] + 50
$linefirst = $lines[$i]
$linexfirst = StringSplit ($linefirst, @TAB, 1)
ToolTip ("Next: " & @CRLF & $linexfirst[2] & @CRLF & "---" & @CRLF & $linexfirst[3], $mousepos[0], $mousepos[1])
ClipPut ($linexfirst[3])



While 1
    Sleep(100)
WEnd

; ==

Func shiftenter()
Send ("+{ENTER}")
EndFunc

; ==

Func totop()
Send ("^{HOME}")
EndFunc

; ==

Func quitt()
Exit
EndFunc

; ==


Func paste()

If $i = $lines[0] Then
MsgBox (0, "No more lines available!", "We're at the bottom of the file, mate", 0)
Return
EndIf

$line = $lines[$i]

$linex = StringSplit ($line, @TAB, 1)

; so $linex[3] is the text to paste

ClipPut ($linex[3])
Sleep ("200")
Send ("^v")
Sleep ("200")
; Send ("^{HOME}")
; Sleep ("200")

$i = $i + 1

$nextline = $lines[$i]

$nextlinex = StringSplit ($nextline, @TAB, 1)

$mousepos = MouseGetPos ()
$mousepos[0] = $mousepos[0] + 50
$mousepos[1] = $mousepos[1] + 50

If $i = $lines[0] Then
ToolTip ("END OF FILE REACHED")
Else
ToolTip ("Next: " & @CRLF & $nextlinex[2] & @CRLF & "---" & @CRLF & $nextlinex[3], $mousepos[0], $mousepos[1])
ClipPut ($nextlinex[3])
EndIf

EndFunc

; ==

Func goback()

If $j = 2 Then
MsgBox (0, "No earlier lines available!", "We're at the top of the file, mate", 0)
$j = 1
Return
EndIf

$i = $i - 1

If $i < 1 Then
$i = 1
$j = $j + 1
EndIf

$nextline = $lines[$i]

$nextlinex = StringSplit ($nextline, @TAB, 1)

$mousepos = MouseGetPos ()
$mousepos[0] = $mousepos[0] + 50
$mousepos[1] = $mousepos[1] + 50
ToolTip ("Next: " & @CRLF & $nextlinex[2] & @CRLF & "---" & @CRLF & $nextlinex[3], $mousepos[0], $mousepos[1])
ClipPut ($nextlinex[3])

EndFunc

; ==

Func goforward()

If $i = $lines[0] Then
MsgBox (0, "No more lines available!", "We're at the bottom of the file, mate", 0)
Return
EndIf

$i = $i + 1

$line = $lines[$i]

$nextline = $lines[$i]

$nextlinex = StringSplit ($nextline, @TAB, 1)

$mousepos = MouseGetPos ()
$mousepos[0] = $mousepos[0] + 50
$mousepos[1] = $mousepos[1] + 50
ToolTip ("Next: " & @CRLF & $nextlinex[2] & @CRLF & "---" & @CRLF & $nextlinex[3], $mousepos[0], $mousepos[1])
ClipPut ($nextlinex[3])

EndFunc

; ==

Func helpme()

MsgBox (0, "GTT Extracttor Paste", "GTT Extracttor Paste reads one line at a time and pastes it. Don't go too fast!" & @CRLF & @CRLF & "~ = paste current text" & @CRLF & "Ctrl + ~ = does Shift + ENTER"  & @CRLF & "WinKey + ~ = does Ctrl + Home" & @CRLF & @CRLF & "Shift + Ctrl + 1 = go back one" & @CRLF & "Shift + Ctrl + 2 = go forward one" & @CRLF & @CRLF & "Ctrl + ? = show shortcuts" & @CRLF & "WinKey + Q = close script", 0)


EndFunc

; ==

Func curl0()
Send ("{{}0{}}")
EndFunc

Func curl1()
Send ("{{}1{}}")
EndFunc

Func curl2()
Send ("{{}2{}}")
EndFunc

Func curl3()
Send ("{{}3{}}")
EndFunc

